VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OGRECams"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_From As D3DVECTOR
Private m_At As D3DVECTOR
Private m_WorldUp As D3DVECTOR
Private m_matWorld As D3DMATRIX
Private m_matView As D3DMATRIX
Private m_matProj As D3DMATRIX

Private m_Roll As Single
Private m_FOV As Single
Private m_Near As Single
Private m_Far As Single

Private m_LookH As Single
Private m_LookV As Single
Private m_MaxLookV As Single

Public Sub MoveAtHRelative(Angle As Single, Optional Xscale As Single = 1, Optional Zscale As Single = 1)
    m_LookH = m_LookH + Angle
    If m_LookH > 360 Then
        m_LookH = m_LookH - 360
    ElseIf m_LookH < 0 Then
        m_LookH = m_LookH + 360
    End If
    m_At = MakeVector(m_From.x + Cos(0.0174533 * m_LookH) * Xscale, m_At.y, m_From.z + Sin(0.0174533 * m_LookH) * Zscale)
    LoadView
End Sub

Public Sub MoveAtVRelative(Angle As Single)
    m_LookV = m_LookV + Angle
    If m_LookV > m_MaxLookV Then
        m_LookV = m_MaxLookV
    ElseIf m_LookV < -m_MaxLookV Then
        m_LookV = -m_MaxLookV
    Else
        m_At = MakeVector(m_At.x, m_At.y + Angle, m_At.z)
        LoadView
    End If
End Sub

Public Property Let MaxVertLook(Angle As Single)
    If Angle > 180 Then Angle = 180
    m_MaxLookV = Angle
End Property

Public Property Get MaxVertLook() As Single
    MaxVertLook = m_MaxLookV
End Property

Public Property Get LookVert() As Single
    LookVert = m_LookV
End Property

Public Property Get LookHorz() As Single
    LookHorz = m_LookH
End Property

Public Property Get WorldUp() As D3DVECTOR
    WorldUp = m_WorldUp
End Property

Public Property Get CameraAt() As D3DVECTOR
    CameraAt = m_At
End Property

Public Property Get CameraFrom() As D3DVECTOR
    CameraFrom = m_From
End Property

Public Sub Create(Optional FromX As Single = 0, Optional FromY As Single = 0, _
    Optional FromZ As Single = -15, Optional AtX As Single = 0, Optional AtY As Single = 0, _
    Optional AtZ As Single = 0, Optional NearPlane As Single = 1, Optional FarPLane As Single = 1000)
    
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGRECam: Create"
                
    m_WorldUp = MakeVector(0, 1, 0)
    m_From = MakeVector(FromX, FromY, FromZ)
    m_At = MakeVector(AtX, AtY, AtZ)
    m_Near = NearPlane
    m_Far = FarPLane
    LoadView
        
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub

Public Sub MoveCameraRelative(Optional FromX As Single = 0, Optional FromY As Single = 0, Optional FromZ As Single = 0, _
    Optional AtX As Single = 0, Optional AtY As Single = 0, Optional AtZ As Single = 0)
    
    On Error GoTo errs
    
    m_From = MakeVector(m_From.x + FromX, m_From.y + FromY, m_From.z + FromZ)
    m_At = MakeVector(m_At.x + AtX, m_At.y + AtY, m_At.z + AtZ)
    LoadView
    
    Exit Sub
errs:
    With GUIelements.GetElement("CONSOLE")
        .PrintData ""
        .PrintData "Error in OGREcam: MoveRelative"
    End With
End Sub

Public Sub Move(Optional FromX As Single, Optional FromY As Single, Optional FromZ As Single)
    On Error GoTo errs
    m_From = MakeVector(IIf(IsMissing(FromX), m_From.x, FromX), IIf(IsMissing(FromY), m_From.y, FromY), IIf(IsMissing(FromZ), m_From.z, FromZ))
    LoadView
    Exit Sub
errs:
    With GUIelements.GetElement("CONSOLE")
        .PrintData ""
        .PrintData "Error in OGREcam: Move"
    End With
End Sub

Public Sub Look(Optional AtX As Single, Optional AtY As Single, Optional AtZ As Single)
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGRECam: Look"
    m_At = MakeVector(IIf(IsMissing(AtX), m_At.x, AtX), IIf(IsMissing(AtY), m_At.y, AtY), IIf(IsMissing(AtZ), m_At.z, AtZ))
    LoadView
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub

Public Sub Range(Optional NearPlane As Single, Optional FarPLane As Single, Optional FOV As Single, Optional Roll As Single)
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGRECam: Range"
        
    If Not IsMissing(Roll) Then m_Roll = Roll
    If Not IsMissing(FOV) Then m_FOV = FOV * 0.0174532925222
    If Not IsMissing(NearPlane) Then m_Near = NearPlane
    If Not IsMissing(FarPLane) Then m_Far = FarPLane
    LoadView
    
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub

Public Sub LoadView()
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGRECam: LoadView"
            
    Dim x As Single, radian As Single
    Dim sDesc As DDSURFACEDESC2
    
    DX7.IdentityMatrix m_matWorld
    Device.SetTransform D3DTRANSFORMSTATE_WORLD, m_matWorld

    DX7.IdentityMatrix m_matView
    DX7.ViewMatrix m_matView, m_From, m_At, m_WorldUp, m_Roll
    Device.SetTransform D3DTRANSFORMSTATE_VIEW, m_matView

    sPrimary.GetSurfaceDesc sDesc
    
    DX7.IdentityMatrix m_matProj
    radian = m_FOV / 2
    x = sDesc.lHeight / sDesc.lWidth
    With m_matProj
        .rc11 = Cos(radian) / Sin(radian)
        .rc22 = Cos(radian * x) / Sin(radian * x)
        .rc33 = m_Far / (m_Far - m_Near)
        .rc43 = -.rc33 * m_Near
        .rc34 = 1
        Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, m_matProj
    End With
    
    DX7.IdentityMatrix matSet
    DX7.MatrixMultiply matSet, m_matWorld, m_matView
    DX7.MatrixMultiply matSet, matSet, m_matProj
    
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub

Public Function CaptureWindow(filename As String) As Boolean
    Dim hDCMemory As Long
    Dim hBmp As Long
    Dim hBmpPrev As Long
    Dim R As Long
    Dim hDCSrc As Long
        
    hDCSrc = GetDC(WindowHwnd(1))
    hDCMemory = CreateCompatibleDC(hDCSrc)
    hBmp = CreateCompatibleBitmap(hDCSrc, OGREForm.ScaleX(OGREForm.ScaleWidth, OGREForm.ScaleMode, vbPixels), _
        OGREForm.ScaleY(OGREForm.ScaleHeight, OGREForm.ScaleMode, vbPixels))
    hBmpPrev = SelectObject(hDCMemory, hBmp)
        
    R = BitBlt(hDCMemory, 0, 0, OGREForm.ScaleX(OGREForm.ScaleWidth, OGREForm.ScaleMode, vbPixels), _
        OGREForm.ScaleY(OGREForm.ScaleHeight, OGREForm.ScaleMode, vbPixels), hDCSrc, 0, 0, vbSrcCopy)
    
    hBmp = SelectObject(hDCMemory, hBmpPrev)
    R = DeleteDC(hDCMemory)
    R = ReleaseDC(WindowHwnd(1), hDCSrc)
        
    Dim Pic As PicBmp
    Dim IPic As IPicture
    Dim IID_IDispatch As GUID
    With IID_IDispatch
        .Data1 = &H20400
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With
    With Pic
        .Size = Len(Pic)
        .Type = vbPicTypeBitmap
        .hBmp = hBmp
        .hPal = 0
    End With
    R = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic)
    SavePicture IPic, filename
    CaptureWindow = True
    Exit Function
End Function

Private Sub Class_Initialize()
    ClipWidth = m_OgreView.lWidth / 2
    ClipHeight = m_OgreView.lHeight / 2
    m_FOV = 90 * 0.0174532925222
    m_MaxLookV = 120
    m_Roll = 0
End Sub
