VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OGREMeshes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Option Base 1

Private Type MeshInfo
    Texture As String
    NumVertices As Long
    Vertices() As D3DVERTEX
    DrawStyle As CONST_D3DPRIMITIVETYPE
    Center As D3DVECTOR
    Radius As Single
End Type
'Private Centers() As D3DVECTOR
'Private Radius() As Single
'Private Spheres() As Long
Private m_Meshes() As MeshInfo

Private m_NumMeshes As Long

Public Property Get NumMeshes() As Long
    NumMeshes = m_NumMeshes
End Property

Public Sub DrawAll()
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGREMeshVB: DrawAll"
    Dim I As Long
    
    'ReDim Spheres(m_NumMeshes) As Long
    'Spheres(1) = Device.ComputeSphereVisibility(Centers(1), Radius(1)) And D3DSTATUS_CLIPINTERSECTIONALL
    
    For I = 1 To m_NumMeshes
        With m_Meshes(I)
            If (Device.ComputeSphereVisibility(.Center, .Radius) And D3DSTATUS_CLIPINTERSECTIONALL) = 0 Then
            'If Spheres(I) = 0 Then
                If oldTexture <> .Texture And .Texture <> "" Then
                    Device.SetTexture 0, Surfaces.Info(.Texture)
                    oldTexture = .Texture
                End If
                If .DrawStyle = D3DPT_TRIANGLESTRIP Then
                    PolyCount = PolyCount + .NumVertices - 2
                Else
                    PolyCount = PolyCount + .NumVertices * 0.33
                End If
                Device.DrawPrimitive .DrawStyle, D3DFVF_VERTEX, .Vertices(1), .NumVertices, D3DDP_DEFAULT
            End If
        End With
    Next I
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub
        
Public Function Create(Optional TextureName As String, Optional DrawStyle As CONST_D3DPRIMITIVETYPE = D3DPT_TRIANGLESTRIP) As Long
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGREMesh: Create"
        
    m_NumMeshes = m_NumMeshes + 1
    ReDim Preserve m_Meshes(m_NumMeshes)
'    ReDim Preserve Radius(m_NumMeshes)
'    ReDim Preserve Centers(m_NumMeshes)
    If Not IsMissing(TextureName) Then m_Meshes(m_NumMeshes).Texture = TextureName
    m_Meshes(m_NumMeshes).DrawStyle = DrawStyle
    Create = m_NumMeshes
    Exit Function
errs:
    Call anErr.AppErr(ErrString)
End Function

Public Sub CreateVertex(Meshindex As Long, x As Single, y As Single, z As Single, tu As Single, tv As Single)
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGREMesh: CreateVertex"
            
    With m_Meshes(Meshindex)
        .NumVertices = .NumVertices + 1
        If .NumVertices > 65535 Then
            MsgBox ("Too Many Vertices for Constructed Solid.")
        Else
            ReDim Preserve .Vertices(.NumVertices)
            DX7.CreateD3DVertex x, y, z, 0, 0, 1, tu, tv, .Vertices(.NumVertices)
        End If
    End With
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub

Public Sub SetSphere(Meshindex As Long, Center As D3DVECTOR, Radii As Single)
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGREMesh: SetRadius"
    Dim VBdesc As D3DVERTEXBUFFERDESC
        
    m_Meshes(Meshindex).Radius = Radii
    m_Meshes(Meshindex).Center = Center
    'Radius(Meshindex) = Radii
    'Centers(Meshindex) = Center
    
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub
