VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OGRESurfaces"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum TEXTUREFLAGS
    D3DTEXTR_DEFAULT = 0
    D3DTEXTR_TRANSPARENTBLACK = 1
    D3DTEXTR_TRANSPARENTWHITE = 2
End Enum

Const SRCCOPY = &HCC0020

Public Enum Bitmaps
    bmp = 1
    JPG = 2
    GIF = 3
End Enum

Private m_Surfaces As New Collection

Public Sub Remove(sName As String)
    m_Surfaces.Remove sName
End Sub

Public Sub CreateSurface(sFileName As String, SurfaceName As String, Optional High As Long = 0, Optional Low As Long = 0)
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGRESurface: CreateSurface"

    Dim ddsd As DDSURFACEDESC2
    Dim aSurface As DirectDrawSurface7
        
    Set aSurface = DD.CreateSurfaceFromFile(sFileName, ddsd)
    Dim ColorKey As DDCOLORKEY
    With ColorKey
        .High = High
        .Low = Low
    End With
    aSurface.SetColorKey DDCKEY_SRCBLT, ColorKey
    
    m_Surfaces.Add aSurface, SurfaceName
    Set aSurface = Nothing
    
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub

Public Sub CreateTexture(sFileName As String, SurfaceName As String, Optional BitMapType As Bitmaps = bmp, _
    Optional High As Long = 0, Optional Low As Long = 0, Optional Tex As Boolean = False, Optional ExtraFlags As TEXTUREFLAGS)
    
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGRESurface: Texture"

    Dim ddsd As DDSURFACEDESC2
    Dim aSurface As DirectDrawSurface7
        
    ErrString = "OGRESurface: EnumTextureFormats"
    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim I As Long
    ddsd.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    Set enumTex = Device.GetTextureFormatsEnum()
    For I = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(I, ddsd.ddpfPixelFormat)
        ErrString = "OGRESurface: EnumTextureFormats2" & I
        With ddsd.ddpfPixelFormat
            ErrString = "OGRESurface: EnumTextureFormats3"
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
            If ((D3DTEXTR_TRANSPARENTBLACK And ExtraFlags) _
                Or (D3DTEXTR_TRANSPARENTWHITE And ExtraFlags)) Then
                    If (.lRGBAlphaBitMask = 0) Then bOK = False
            Else
                If (.lRGBAlphaBitMask <> 0) Then bOK = False
            End If
        End With
        If bOK = True Then Exit For
    Next
    Set enumTex = Nothing
        
    If bOK = False Then
        MsgBox ("Unable to find 16bit surface support on your hardware - exiting")
        GoTo errs
    End If
    
    If (((D3DTEXTR_TRANSPARENTBLACK And ExtraFlags) Or (D3DTEXTR_TRANSPARENTWHITE And ExtraFlags))) Then
            ddsd.ddpfPixelFormat.lFlags = DDPF_ALPHAPIXELS Or DDPF_RGB
            ddsd.lFlags = ddsd.lFlags Or DDSD_PIXELFORMAT
    Else
        ddsd.ddpfPixelFormat.lFlags = DDPF_RGB
    End If
    
    If BitMapType <> bmp Then
        ErrString = "OGRESurface: Load Non-BMP"
        Dim hdcPicture As Long
        Dim hdcSurface As Long
        Dim Picture As StdPicture
        Set Picture = LoadPicture(sFileName)
        With ddsd
            .lFlags = .lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
            .ddsCaps.lCaps = IIf(Tex, DDSCAPS_TEXTURE, DDSCAPS_OFFSCREENPLAIN)
            .lWidth = Screen.ActiveForm.ScaleX(Picture.Width, vbHimetric, vbPixels)
            .lHeight = Screen.ActiveForm.ScaleY(Picture.Height, vbHimetric, vbPixels)
            If Tex Then
                ddsd.ddsCaps.lCaps2 = DDSCAPS2_D3DTEXTUREMANAGE
                ddsd.lTextureStage = 0
            End If
        End With
            
        Set aSurface = DD.CreateSurface(ddsd)
        hdcPicture = CreateCompatibleDC(ByVal 0&)
        SelectObject hdcPicture, Picture.Handle
        aSurface.restore
        hdcSurface = aSurface.GetDC
        StretchBlt hdcSurface, 0, 0, ddsd.lWidth, ddsd.lHeight, hdcPicture, 0, 0, _
            Screen.ActiveForm.ScaleX(Picture.Width, vbHimetric, vbPixels), _
            Screen.ActiveForm.ScaleY(Picture.Height, vbHimetric, vbPixels), SRCCOPY
        aSurface.ReleaseDC hdcSurface
        DeleteDC hdcPicture
        Set Picture = Nothing
    Else
        ErrString = "OGRESurface: LoadBMP"
        ddsd.ddsCaps.lCaps = DDSCAPS_TEXTURE
        ddsd.ddsCaps.lCaps2 = DDSCAPS2_D3DTEXTUREMANAGE
        ddsd.lTextureStage = 0
        Set aSurface = DD.CreateSurfaceFromFile(sFileName, ddsd)
    End If
        
    If ((D3DTEXTR_TRANSPARENTBLACK = ExtraFlags) Or (D3DTEXTR_TRANSPARENTWHITE = ExtraFlags)) Then
        ErrString = "OGRESurface: ExtraTextureFlags"
        Dim ddsd3 As DDSURFACEDESC2
        Dim mem() As Integer
        Dim lAlphaMask As Long
        Dim lRGBMask As Long
        Dim lColorKey As Long
        Dim C As Long
        Dim x As Long
        Dim y As Long
        Dim r1 As RECT
    
        ReDim mem(ddsd.lHeight * ddsd.lPitch)
    
        With ddsd.ddpfPixelFormat
            lAlphaMask = .lRGBAlphaBitMask
            lRGBMask = .lRBitMask Or .lGBitMask Or .lBBitMask
        End With
        If (ExtraFlags And D3DTEXTR_TRANSPARENTWHITE) Then lColorKey = lRGBMask     'color key on white
        If (ExtraFlags And D3DTEXTR_TRANSPARENTBLACK) Then lColorKey = 0                  'color key on black
            
        r1.Bottom = ddsd.lHeight
        r1.Right = ddsd.lWidth
        aSurface.Lock r1, ddsd3, DDLOCK_WAIT, 0
    
        ' Add an opaque alpha value to each non-colorkeyed pixel
        For y = 0 To ddsd3.lHeight - 1
            For x = 0 To ddsd3.lWidth - 1
                C = aSurface.GetLockedPixel(x, y)
                If C And lRGBMask <> lColorKey Then
                    aSurface.SetLockedPixel x, y, C Or lAlphaMask
                End If
            Next
        Next
        aSurface.Unlock r1
    End If
        
    Dim ColorKey As DDCOLORKEY
    With ColorKey
        .High = High
        .Low = Low
    End With
    aSurface.SetColorKey DDCKEY_SRCBLT, ColorKey
        
    If m_Surfaces Is Nothing Then Set m_Surfaces = New Collection
    m_Surfaces.Add aSurface, SurfaceName
    Set aSurface = Nothing
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub

Public Property Get Info(SurfaceName As String) As DirectDrawSurface7
    On Error Resume Next
    Set Info = m_Surfaces(SurfaceName)
End Property

Private Sub Class_Terminate()
    Set m_Surfaces = Nothing
End Sub
